package com.bfms.quartz.task;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.alibaba.fastjson2.JSONArray;
import com.alibaba.fastjson2.JSONObject;
import com.bfms.common.core.redis.RedisCache;
import com.bfms.common.utils.http.HttpUtils;
/**
 * 定时任务调度测试
 * 
 * @author MET
 */
@Component("ShuiWenTask")
public class ShuiWenTask
{
	protected final Logger logger = LoggerFactory.getLogger(ShuiWenTask.class);
	@Autowired
	private RedisCache redisCache;
	
 
    public void getShuiWenTask(String params)
    {
    	logger.info("拉取水库数据");
        //查询宁乡预警信号
        String param = "";
        String sendGet = HttpUtils.sendGet(SHUIWENUris.SKlistURI , param);
        JSONObject resultObject = JSONObject.parseObject(sendGet);
        JSONArray allList = resultObject.getJSONArray("data");
        
        JSONArray NingXiangSKList = new JSONArray();
        JSONArray NingXiangYLZList = new JSONArray();
        JSONArray NingXiangHDZList = new JSONArray();
        for (int i=0;i<allList.size();i++) {
        	JSONObject obj = allList.getJSONObject(i);
        	if(obj.getString("ADDVCD").equals("430182") && 
        			"水库".indexOf(obj.getString("STNM"))>=0) {
        		JSONObject OBJ = new JSONObject();
        		OBJ.put("id", obj.getString("STCD").trim());
        		OBJ.put("nm", obj.getString("STNM").trim());
        		OBJ.put("type", "3");
        		OBJ.put("region", obj.getString("ADDVCD").trim());
        		List<BigDecimal> a = new ArrayList<BigDecimal>();
        		a.add(obj.getBigDecimal("LGTD"));
        		a.add(obj.getBigDecimal("LTTD")) ;
        		OBJ.put("latlng", a);
        		NingXiangSKList.add(OBJ);
        		
        	}
		}
        redisCache.setCacheObject("NingXiang430182:reservoirListGIS", NingXiangSKList);
        System.out.println("水库信息拉取成功,水库数量："+NingXiangSKList.size());
 
    }
        
        	
       
}
