package com.bfms.system.domain;

import java.util.Date;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import com.bfms.common.annotation.Excel;
import com.bfms.common.core.domain.BaseEntity;
import com.fasterxml.jackson.annotation.JsonFormat; 
/**
 * 文件系统对象 qxt_file_data
 * 
 * @author MET
 * @date 2023-03-21
 */
public class QxtFileData extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** id */
    private String id;

    /** 文件名路径 */
    @Excel(name = "文件名路径")
    private String filenmuri;

    /** 文件访问ip */
    @Excel(name = "文件访问ip")
    private String fileip;

    /** 文件描述 */
    @Excel(name = "文件描述")
    private String des;

    /** 创建日期 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "创建日期", width = 30, dateFormat = "yyyy-MM-dd")
    private Date createdt;

    /** 发布日期 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "发布日期", width = 30, dateFormat = "yyyy-MM-dd")
    private Date publidt;

    /** 文件所属分类集合 */
    @Excel(name = "文件所属分类集合")
    private String categoryids;

    /** 文件所属分类 */
    @Excel(name = "文件所属分类")
    private String cateid;

    /** 状态0无效1有效2隐藏 */
    @Excel(name = "状态0无效1有效2隐藏")
    private Integer sts;

    /** 文件名称 */
    @Excel(name = "文件名称")
    private String filenm;

    /** 文件绝对路径地址 */
    @Excel(name = "文件绝对路径地址")
    private String absourl;

    /** 是否生成pdf0否1是 */
    @Excel(name = "是否生成pdf0否1是")
    private Integer ispdf;

    /** 下载地址 */
    @Excel(name = "下载地址")
    private String downurl;

    /** 地区编号(43000) */
    @Excel(name = "地区编号(43000)")
    private String areacode;

    /** 地区名(NingXiang) */
    @Excel(name = "地区名(NingXiang)")
    private String areaflor;
    
    private String ddownurl;
    
    

    public String getDdownurl() {
		return ddownurl;
	}

	public void setDdownurl(String ddownurl) {
		this.ddownurl = ddownurl;
	}

	public void setId(String id) 
    {
        this.id = id;
    }

    public String getId() 
    {
        return id;
    }
    public void setFilenmuri(String filenmuri) 
    {
        this.filenmuri = filenmuri;
    }

    public String getFilenmuri() 
    {
        return filenmuri;
    }
    public void setFileip(String fileip) 
    {
        this.fileip = fileip;
    }

    public String getFileip() 
    {
        return fileip;
    }
    public void setDes(String des) 
    {
        this.des = des;
    }

    public String getDes() 
    {
        return des;
    }
    public void setCreatedt(Date createdt) 
    {
        this.createdt = createdt;
    }

    public Date getCreatedt() 
    {
        return createdt;
    }
    public void setPublidt(Date publidt) 
    {
        this.publidt = publidt;
    }

    public Date getPublidt() 
    {
        return publidt;
    }
    public void setCategoryids(String categoryids) 
    {
        this.categoryids = categoryids;
    }

    public String getCategoryids() 
    {
        return categoryids;
    }
    public void setCateid(String cateid) 
    {
        this.cateid = cateid;
    }

    public String getCateid() 
    {
        return cateid;
    }
    public void setSts(Integer sts) 
    {
        this.sts = sts;
    }

    public Integer getSts() 
    {
        return sts;
    }
    public void setFilenm(String filenm) 
    {
        this.filenm = filenm;
    }

    public String getFilenm() 
    {
        return filenm;
    }
    public void setAbsourl(String absourl) 
    {
        this.absourl = absourl;
    }

    public String getAbsourl() 
    {
        return absourl;
    }
    public void setIspdf(Integer ispdf) 
    {
        this.ispdf = ispdf;
    }

    public Integer getIspdf() 
    {
        return ispdf;
    }
    public void setDownurl(String downurl) 
    {
        this.downurl = downurl;
    }

    public String getDownurl() 
    {
        return downurl;
    }
    public void setAreacode(String areacode) 
    {
        this.areacode = areacode;
    }

    public String getAreacode() 
    {
        return areacode;
    }
    public void setAreaflor(String areaflor) 
    {
        this.areaflor = areaflor;
    }

    public String getAreaflor() 
    {
        return areaflor;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("id", getId())
            .append("filenmuri", getFilenmuri())
            .append("fileip", getFileip())
            .append("des", getDes())
            .append("createdt", getCreatedt())
            .append("publidt", getPublidt())
            .append("categoryids", getCategoryids())
            .append("cateid", getCateid())
            .append("sts", getSts())
            .append("filenm", getFilenm())
            .append("absourl", getAbsourl())
            .append("ispdf", getIspdf())
            .append("downurl", getDownurl())
            .append("areacode", getAreacode())
            .append("areaflor", getAreaflor())
            .toString();
    }
}
