package com.bfms.system.domain;

import java.util.Date;

import com.bfms.common.annotation.Excel;
import com.bfms.common.core.domain.BaseEntity;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle; 

/**
 * 预警信息对象 sys_yjdata
 * 
 * @author MET
 * @date 2023-10-09
 */
public class SysYjdata extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** $column.columnComment */
    private Long id;

    /** 预警图片,数据为HN12379网站图片路径 */
    @Excel(name = "预警图片,数据为HN12379网站图片路径")
    private String img;

    /** 预警影响地区名称 */
    @Excel(name = "预警影响地区名称")
    private String areadesc;

    /** 预警内容是总还是分 */
    @Excel(name = "预警内容是总还是分")
    private String contenttype;

    /** 预警发布单位机构编码 */
    @Excel(name = "预警发布单位机构编码")
    private String sendercode;

    /** 预警发布单位名称 */
    @Excel(name = "预警发布单位名称")
    private String sender;

    /** 灾种名称 */
    @Excel(name = "灾种名称")
    private String eventname;

    /** 返回数据中此条预警的序号 */
    @Excel(name = "返回数据中此条预警的序号")
    private Long num;

    /** 预警有效时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "预警有效时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date effective;

    /** 灾种级别,中文 */
    @Excel(name = "灾种级别,中文")
    private String severityZh;

    /** 预警录入时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "预警录入时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date entrytime;

    /** 预警或者预警信号 */
    @Excel(name = "预警或者预警信号")
    private String warningsign;

    /** 预警影响地区编码 */
    @Excel(name = "预警影响地区编码")
    private String geocode;

    /** 是否有效预警,0无效,1有效 */
    @Excel(name = "是否有效预警,0无效,1有效")
    private String iseffect;

    /** 灾种编码 */
    @Excel(name = "灾种编码")
    private String eventtype;

    /** 预警内容 */
    @Excel(name = "预警内容")
    private String description;

    /** 预警发布时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "预警发布时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date sendtime;

    /** 预警标题 */
    @Excel(name = "预警标题")
    private String headline;

    /** 预警的任务编码 */
    @Excel(name = "预警的任务编码")
    private String identifier;

    /** 灾种级别,英文 */
    @Excel(name = "灾种级别,英文")
    private String severity;
    
    private Integer top;
    
    private Date sdt;
    private Date edt;
    
    private String queryall;
    
    
    
    

    public String getQueryall() {
		return queryall;
	}

	public void setQueryall(String queryall) {
		this.queryall = queryall;
	}

	public Date getSdt() {
		return sdt;
	}

	public void setSdt(Date sdt) {
		this.sdt = sdt;
	}

	public Date getEdt() {
		return edt;
	}

	public void setEdt(Date edt) {
		this.edt = edt;
	}

	public Integer getTop() {
		return top;
	}

	public void setTop(Integer top) {
		this.top = top;
	}

	public void setId(Long id) 
    {
        this.id = id;
    }

    public Long getId() 
    {
        return id;
    }
    public void setImg(String img) 
    {
        this.img = img;
    }

    public String getImg() 
    {
        return img;
    }
    public void setAreadesc(String areadesc) 
    {
        this.areadesc = areadesc;
    }

    public String getAreadesc() 
    {
        return areadesc;
    }
    public void setContenttype(String contenttype) 
    {
        this.contenttype = contenttype;
    }

    public String getContenttype() 
    {
        return contenttype;
    }
    public void setSendercode(String sendercode) 
    {
        this.sendercode = sendercode;
    }

    public String getSendercode() 
    {
        return sendercode;
    }
    public void setSender(String sender) 
    {
        this.sender = sender;
    }

    public String getSender() 
    {
        return sender;
    }
    public void setEventname(String eventname) 
    {
        this.eventname = eventname;
    }

    public String getEventname() 
    {
        return eventname;
    }
    public void setNum(Long num) 
    {
        this.num = num;
    }

    public Long getNum() 
    {
        return num;
    }
    public void setEffective(Date effective) 
    {
        this.effective = effective;
    }

    public Date getEffective() 
    {
        return effective;
    }
    public void setSeverityZh(String severityZh) 
    {
        this.severityZh = severityZh;
    }

    public String getSeverityZh() 
    {
        return severityZh;
    }
    public void setEntrytime(Date entrytime) 
    {
        this.entrytime = entrytime;
    }

    public Date getEntrytime() 
    {
        return entrytime;
    }
    public void setWarningsign(String warningsign) 
    {
        this.warningsign = warningsign;
    }

    public String getWarningsign() 
    {
        return warningsign;
    }
    public void setGeocode(String geocode) 
    {
        this.geocode = geocode;
    }

    public String getGeocode() 
    {
        return geocode;
    }
    public void setIseffect(String iseffect) 
    {
        this.iseffect = iseffect;
    }

    public String getIseffect() 
    {
        return iseffect;
    }
    public void setEventtype(String eventtype) 
    {
        this.eventtype = eventtype;
    }

    public String getEventtype() 
    {
        return eventtype;
    }
    public void setDescription(String description) 
    {
        this.description = description;
    }

    public String getDescription() 
    {
        return description;
    }
    public void setSendtime(Date sendtime) 
    {
        this.sendtime = sendtime;
    }

    public Date getSendtime() 
    {
        return sendtime;
    }
    public void setHeadline(String headline) 
    {
        this.headline = headline;
    }

    public String getHeadline() 
    {
        return headline;
    }
    public void setIdentifier(String identifier) 
    {
        this.identifier = identifier;
    }

    public String getIdentifier() 
    {
        return identifier;
    }
    public void setSeverity(String severity) 
    {
        this.severity = severity;
    }

    public String getSeverity() 
    {
        return severity;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("id", getId())
            .append("img", getImg())
            .append("areadesc", getAreadesc())
            .append("contenttype", getContenttype())
            .append("sendercode", getSendercode())
            .append("sender", getSender())
            .append("eventname", getEventname())
            .append("num", getNum())
            .append("effective", getEffective())
            .append("severityZh", getSeverityZh())
            .append("entrytime", getEntrytime())
            .append("warningsign", getWarningsign())
            .append("geocode", getGeocode())
            .append("iseffect", getIseffect())
            .append("eventtype", getEventtype())
            .append("description", getDescription())
            .append("sendtime", getSendtime())
            .append("headline", getHeadline())
            .append("identifier", getIdentifier())
            .append("severity", getSeverity())
            .toString();
    }
}
