package com.bfms.system.mapper;

import java.util.List;

import com.bfms.system.domain.QxtFileData;

/**
 * 文件系统Mapper接口
 * 
 * @author MET
 * @date 2023-03-21
 */
public interface QxtFileDataMapper 
{
    /**
     * 查询文件系统
     * 
     * @param id 文件系统主键
     * @return 文件系统
     */
    public QxtFileData selectQxtFileDataById(String id);

    /**
     * 查询文件系统列表
     * 
     * @param qxtFileData 文件系统
     * @return 文件系统集合
     */
    public List<QxtFileData> selectQxtFileDataList(QxtFileData qxtFileData);

    /**
     * 新增文件系统
     * 
     * @param qxtFileData 文件系统
     * @return 结果
     */
    public int insertQxtFileData(QxtFileData qxtFileData);

    /**
     * 修改文件系统
     * 
     * @param qxtFileData 文件系统
     * @return 结果
     */
    public int updateQxtFileData(QxtFileData qxtFileData);

    /**
     * 删除文件系统
     * 
     * @param id 文件系统主键
     * @return 结果
     */
    public int deleteQxtFileDataById(String id);

    /**
     * 批量删除文件系统
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteQxtFileDataByIds(String[] ids);

	public List<QxtFileData> selectQxtFileDataListLIMIT(QxtFileData query);
}
