package com.bfms.system.mapper;

import java.util.List;

import com.bfms.system.domain.SysYjdata;

/**
 * 预警信息Mapper接口
 * 
 * @author MET
 * @date 2023-10-09
 */
public interface SysYjdataMapper 
{
    /**
     * 查询预警信息
     * 
     * @param id 预警信息主键
     * @return 预警信息
     */
    public SysYjdata selectSysYjdataById(Long id);

    /**
     * 查询预警信息列表
     * 
     * @param sysYjdata 预警信息
     * @return 预警信息集合
     */
    public List<SysYjdata> selectSysYjdataList(SysYjdata sysYjdata);

    /**
     * 新增预警信息
     * 
     * @param sysYjdata 预警信息
     * @return 结果
     */
    public int insertSysYjdata(SysYjdata sysYjdata);

    /**
     * 修改预警信息
     * 
     * @param sysYjdata 预警信息
     * @return 结果
     */
    public int updateSysYjdata(SysYjdata sysYjdata);

    /**
     * 删除预警信息
     * 
     * @param id 预警信息主键
     * @return 结果
     */
    public int deleteSysYjdataById(Long id);

    /**
     * 批量删除预警信息
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSysYjdataByIds(Long[] ids);

	public Integer selectSysYjdataListCount(SysYjdata query);
}
