package com.bfms.system.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bfms.system.domain.QxtFileData;
import com.bfms.system.mapper.QxtFileDataMapper;
import com.bfms.system.service.IQxtFileDataService;

/**
 * 文件系统Service业务层处理
 * 
 * @author MET
 * @date 2023-03-21
 */
@Service
public class QxtFileDataServiceImpl implements IQxtFileDataService 
{
    @Autowired
    private QxtFileDataMapper qxtFileDataMapper;

    /**
     * 查询文件系统
     * 
     * @param id 文件系统主键
     * @return 文件系统
     */
    @Override
    public QxtFileData selectQxtFileDataById(String id)
    {
        return qxtFileDataMapper.selectQxtFileDataById(id);
    }

    /**
     * 查询文件系统列表
     * 
     * @param qxtFileData 文件系统
     * @return 文件系统
     */
    @Override
    public List<QxtFileData> selectQxtFileDataList(QxtFileData qxtFileData)
    {
        return qxtFileDataMapper.selectQxtFileDataList(qxtFileData);
    }

    /**
     * 新增文件系统
     * 
     * @param qxtFileData 文件系统
     * @return 结果
     */
    @Override
    public int insertQxtFileData(QxtFileData qxtFileData)
    {
        return qxtFileDataMapper.insertQxtFileData(qxtFileData);
    }

    /**
     * 修改文件系统
     * 
     * @param qxtFileData 文件系统
     * @return 结果
     */
    @Override
    public int updateQxtFileData(QxtFileData qxtFileData)
    {
        return qxtFileDataMapper.updateQxtFileData(qxtFileData);
    }

    /**
     * 批量删除文件系统
     * 
     * @param ids 需要删除的文件系统主键
     * @return 结果
     */
    @Override
    public int deleteQxtFileDataByIds(String[] ids)
    {
        return qxtFileDataMapper.deleteQxtFileDataByIds(ids);
    }

    /**
     * 删除文件系统信息
     * 
     * @param id 文件系统主键
     * @return 结果
     */
    @Override
    public int deleteQxtFileDataById(String id)
    {
        return qxtFileDataMapper.deleteQxtFileDataById(id);
    }

	@Override
	public List<QxtFileData> selectQxtFileDataListLIMIT(QxtFileData query) {
		// TODO Auto-generated method stub
		return qxtFileDataMapper.selectQxtFileDataListLIMIT(query);
	}
}
