package com.bfms.system.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bfms.system.domain.SysYjdata;
import com.bfms.system.mapper.SysYjdataMapper;
import com.bfms.system.service.ISysYjdataService;

/**
 * 预警信息Service业务层处理
 * 
 * @author MET
 * @date 2023-10-09
 */
@Service
public class SysYjdataServiceImpl implements ISysYjdataService 
{
    @Autowired
    private SysYjdataMapper sysYjdataMapper;

    /**
     * 查询预警信息
     * 
     * @param id 预警信息主键
     * @return 预警信息
     */
    @Override
    public SysYjdata selectSysYjdataById(Long id)
    {
        return sysYjdataMapper.selectSysYjdataById(id);
    }

    /**
     * 查询预警信息列表
     * 
     * @param sysYjdata 预警信息
     * @return 预警信息
     */
    @Override
    public List<SysYjdata> selectSysYjdataList(SysYjdata sysYjdata)
    {
        return sysYjdataMapper.selectSysYjdataList(sysYjdata);
    }

    /**
     * 新增预警信息
     * 
     * @param sysYjdata 预警信息
     * @return 结果
     */
    @Override
    public int insertSysYjdata(SysYjdata sysYjdata)
    {
        return sysYjdataMapper.insertSysYjdata(sysYjdata);
    }

    /**
     * 修改预警信息
     * 
     * @param sysYjdata 预警信息
     * @return 结果
     */
    @Override
    public int updateSysYjdata(SysYjdata sysYjdata)
    {
        return sysYjdataMapper.updateSysYjdata(sysYjdata);
    }

    /**
     * 批量删除预警信息
     * 
     * @param ids 需要删除的预警信息主键
     * @return 结果
     */
    @Override
    public int deleteSysYjdataByIds(Long[] ids)
    {
        return sysYjdataMapper.deleteSysYjdataByIds(ids);
    }

    /**
     * 删除预警信息信息
     * 
     * @param id 预警信息主键
     * @return 结果
     */
    @Override
    public int deleteSysYjdataById(Long id)
    {
        return sysYjdataMapper.deleteSysYjdataById(id);
    }

	@Override
	public Integer selectSysYjdataListCount(SysYjdata query) {
		// TODO Auto-generated method stub
		return sysYjdataMapper.selectSysYjdataListCount(query);
	}
}
